{ PdfGenerator Copyright 1999 by Stefan Menten

  Unit UPdfDefinition
  definitions for PdfGenerator }

unit UPdfDefinition;

interface

uses SysUtils, Classes;

const
  // the PDF Versions
  cPdf10 = 'PDF-1.0';
  cPdf11 = 'PDF-1.1';
  cPdf12 = 'PDF-1.2';

  bOffset = false;

  cMM2Inch = 25.4;
  cInch2UserSpace = 72;
  c_MaxPageCount = 50;
  c_DefFontHeight = 1.25;

  // tags for floating text
  c_Break = '<br>';
  c_FontStart = '<font';
  c_FontEnd = '</font>';

type
  TMediaBox = record
    mbTop, mbLeft, mbHeight, mbWidth: double;
  end;

  TPaper = (A4, A5, A3, Letter, Legal, DL_Envelope);
  TPdfOrientation = (PdfPortrait, PdfLandscape);

  TPdfAlignment = (taPdfLeft, taPdfRight, taPdfCenter, taPdfJustify);

type
  TPdfWriteParDef = record
    HeadingFont:  String;
    HeadingSize:  Integer;
    HeadingAlign: TPdfAlignment;
    TextFont:     String;
    TextSize:     Integer;
    TextAlign:    TPdfAlignment;
    end;

Type
  TPageMargins = record
      Left, Top, Right, Bottom: double;
    end;

function FloatToStrDot(const Float: Double): String;

function GetUserSpaceFromMM(const iMM: Integer): double;

implementation

// --- FloatToStrDot ---------------------------------------
// 13.01.00 21:53:58
// replace the komma with a dot in an float converted to a string
// is needed because german decimal seperater is a komma, but pdf
// needs a dot as decimal separator
function FloatToStrDot(const Float: Double): String;
var
   x: Integer;
begin
//Result := FloatToStr(Float);
Result := FormatFloat('#0.#####', Float);
for x := 1 to Length(Result)-1 do
  if Result[x] = ',' then Result[x] := '.';
end;

// --- GetUserSpaceFromMM ---------------------------------------
// 13.01.00 21:53:22
// convert mm to User Space
//
function GetUserSpaceFromMM(const iMM: Integer): double;
begin
result := (iMM / cMM2Inch) * cInch2UserSpace;
end;
end.
