{ PdfGenerator Copyright 1999 by Stefan Menten

  Unit UPdfImages
  Handling of Images for PdfGenerator }

unit UPdfImages;

interface

uses Windows, SysUtils, Classes, Graphics, Forms;

const c_ColorSpace16 = '0 0 0 128 0 0 0 128 0 128 128 0 0 0 128 ' +
                       '128 0 128 0 128 128 127 127 127 191 191 191 ' +
                       '255 0 0 0 255 0 255 255 0 0 0 255 255 0 255 ' +
                       '0 255 255 255 255 255';

// returns all used colors in a string list
function GetColorsFromBitmap(Bitmap: TBitmap; var sColors: String): Byte;

// return the bitmap data as string of decimals
function GetBitmapData(Bitmap: TBitmap): TMemoryStream;

implementation

// --- GetColorsFromBitmap ---------------------------------------
// 13.01.00 22:01:56
// returns all used colors in a string list
function GetColorsFromBitmap(Bitmap: TBitmap; var sColors: String): Byte;
var
   x, y: Integer;
   tmpColor: String;
   Rgb: TColor;
   slColors: TStringList;
begin
slColors := NIL;
result := 0;
try
slColors := TStringList.create;
// run to each pixel and get color value
with Bitmap do
  for x := 0 to Bitmap.Width do
    for y := 0 to Bitmap.Height do
      begin
      // get color values for each pixel, save separated by blank
      Rgb := Bitmap.Canvas.Pixels[x, y];
      tmpColor := InttoStr(GetRValue(Rgb)) + ' ';
      tmpColor := tmpColor + InttoStr(GetGValue(Rgb)) + ' ';
      tmpColor := tmpColor + InttoStr(GetBValue(Rgb));
      // Wert speichern wenn nicht vorhanden
      if slColors.IndexOf(tmpColor) = -1 then slColors.Add(tmpColor);
      end;
if slColors.Count > 0 then
  begin
  result := slColors.Count;
  for x := 0 to slColors.Count -1 do sColors := sColors + slColors[x] + ' ';
  end;
finally
slColors.Free;
end;
end;

// --- GetBitmapData ---------------------------------------
// 13.01.00 22:02:04
// return the bitmap data as string of decimals
function GetBitmapData(Bitmap: TBitmap): TMemoryStream;
var
   x, y: Integer;
   Row: pByteArray;
begin
result := TMemoryStream.create;
case Bitmap.PixelFormat of
  pf1Bit: begin
          end;
  pf4Bit: begin
          //sStream.Position := 0;
          Bitmap.SaveToStream(result);
{          for y := Bitmap.Height-1 downto 0 do
            begin
            Row := Bitmap.ScanLine[y];
            for x  := 0 to (Bitmap.Width DIV 2)-1 do
                result := result + IntToStr(Row[x]) +' ';}
            Application.ProcessMessages;
            //end;
          end;
  pf8Bit: begin
          end;
  end;
end;

end.
